/*  Copyright 2011 diwaly
 *  This file is part of Volcano Plugin.
 *
 *  Volcano Plugin is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  Volcano Plugin is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with Volcano Plugin.  If not, see <http://www.gnu.org/licenses/>.
 */
package fr.diwaly.volcano;

import java.util.ArrayList;

import org.bukkit.Material;

public class PopBlock {

	private ArrayList<Integer> rateM = new ArrayList<Integer>();
	private ArrayList<Double> rateH = new ArrayList<Double>();
	private ArrayList<Material> mat = new ArrayList<Material>();
	
	
	public PopBlock() {
		
	}
	
	public double getRateH(int i){
		return rateH.get(i);
	}
	public int getRateM(int i){
		return rateM.get(i);
	}
	public Material getMat(int i){
		return mat.get(i);
	}
	public int size(){
		return mat.size();
	}
	
	public boolean put(Double rate, Material m){
		int size = rateH.size();
		int i;
		for(i=0 ; i < size ; i++){
			if(rate > rateH.get(i)){
				rateH.add(i,rate);
				mat.add(i,m);
				return true;
			}
		}
		rateH.add(rate);
		mat.add(m);
		return false;
	}
	
	public PopBlock human(){
		rateH = new ArrayList<Double>();
		int pre = 0;
		for (int i=0 ; i < rateM.size() ; i++) {
			rateH.add((double)(rateM.get(i) - pre)/100);
			pre = rateM.get(i);
		}
		return this;
	}
	public PopBlock machine(){
		rateM = new ArrayList<Integer>();
		int pre = 0;
		for (int i=0 ; i < rateH.size() ; i++) {
			int rate = (int)(rateH.get(i)*100);
			rateM.add(rate + pre);
			pre += rate;
		}
		return this;
	}
}
