/*  Copyright 2011 diwaly
 *  This file is part of Volcano Plugin.
 *
 *  Volcano Plugin is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  Volcano Plugin is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with Volcano Plugin.  If not, see <http://www.gnu.org/licenses/>.
 */
package fr.diwaly.volcano;

import org.bukkit.Location;
import org.bukkit.entity.Player;

public class VolcanoActive implements Runnable{

	int taskId;
	boolean start = true;
	
	public VolcanoActive(){
		// Dmarre en 1er
		taskId = Plugin.server.getScheduler().scheduleAsyncRepeatingTask(Plugin.him,this,10,300);
	}
	
	@Override
	public void run() {
		// Permet de load les volcans de different monde
		if(start){
			Plugin.load();
			start = false;
		}
		
		boolean enable;
		boolean canErupt;
		try{
			for (Volcano volcano : Plugin.listVolcano) {
				if(volcano.isStart()){
					enable = false;
					canErupt = false;
					for(Player player : Plugin.server.getWorld(volcano.world.getName()).getPlayers()){
						Location loc = player.getLocation();
						if(volcano.inZoneActiv(loc.getBlockX(), loc.getBlockZ())){
							enable = true;
							if(volcano.insideChunk(loc.getBlockX(), loc.getBlockZ())){
								canErupt = true;
							}
							break;
						}
					}
					volcano.enable = enable;
					volcano.canErupt = canErupt;
				}
			}
		}catch(Exception e){
			Plugin.log("Error Thread Active: "+e.getMessage());
		}
	}
}
