/*  Copyright 2011 diwaly
 *  This file is part of Volcano Plugin.
 *
 *  Volcano Plugin is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  Volcano Plugin is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with Volcano Plugin.  If not, see <http://www.gnu.org/licenses/>.
 */
package fr.diwaly.volcano;

import java.util.Random;

public class VolcanoErupt implements Runnable{

	static final public int CHECK = 0;
	static final public int ERUPT = 1;
	public int id;
	private int state;
	private Volcano volcano;
	private boolean inEruption = false;
	private VolcanoErupt master;
	
	public VolcanoErupt (Volcano volcano, int state){
		this(volcano, state, null);
	}
	
	public VolcanoErupt (Volcano volcano, int state, VolcanoErupt master){
		this.volcano = volcano;
		this.state = state;
		this.master = master;
		if(state == CHECK){
			id = Plugin.server.getScheduler().scheduleAsyncRepeatingTask(Plugin.him,this,new Random().nextInt(150)+50,150);
		}
	}
	
	@Override
	public void run() {
		if(state == CHECK && !inEruption){
			if(volcano.explosive && volcano.canErupt && volcano.enable && volcano.inEruption()){
				//Plugin.log(volcano.name+" is preparing at an eruption !");
				Random rand = new Random();
				inEruption = true;
				int timerExplo = 0;
				int delay = 0;
				if(volcano.timerExplo > 0)
					timerExplo = volcano.timerExplo;
				if(volcano.delayExplo > 0)
					delay = rand.nextInt(volcano.delayExplo);
				long second = timerExplo + delay;
				for(int i = 0 ; i < volcano.nbExplo ; i++){
					Plugin.server.getScheduler().scheduleSyncDelayedTask(Plugin.him, new VolcanoErupt(volcano, ERUPT, this), second);
					int plus = rand.nextInt(3)*20;
					Plugin.server.getScheduler().scheduleSyncDelayedTask(Plugin.him, new VolcanoErupt(volcano, ERUPT, this), second+plus);
					second += 40; //  +2seconds
				}
			}
		}else if(state == ERUPT){
			master.inEruption = false;
			volcano.eruption2();
		}	
	}	
	
}
