/*  Copyright 2011 diwaly
 *  This file is part of Volcano Plugin.
 *
 *  Volcano Plugin is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  Volcano Plugin is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with Volcano Plugin.  If not, see <http://www.gnu.org/licenses/>.
 */
package fr.diwaly.volcano;

import org.bukkit.Material;
import org.bukkit.block.Block;
import org.bukkit.event.Event;
import org.bukkit.event.block.BlockFromToEvent;
import org.bukkit.event.block.BlockListener;
import org.bukkit.plugin.PluginManager;

public class VolcanoLavaListener extends BlockListener{
	
	public VolcanoLavaListener(){

		PluginManager pm = Plugin.server.getPluginManager();
		pm.registerEvent(Event.Type.BLOCK_FROMTO, this, Event.Priority.Normal, Plugin.him);
	}

	public void onBlockFromTo(BlockFromToEvent event){
		Block block = event.getBlock();
	
		for (Volcano volcano : Plugin.listVolcano) {
			if(volcano.world.getName().equals(block.getWorld().getName())){		
				if(block.getType() == Material.LAVA || block.getType() == Material.STATIONARY_LAVA){				
					if(volcano.inside(block.getX(),block.getY(), block.getZ())){
						volcano.newFlowed(block);
					}
				}
			}
		}
	}	
}
