/*  Copyright 2011 diwaly
 *  This file is part of Volcano Plugin.
 *
 *  Volcano Plugin is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  Volcano Plugin is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with Volcano Plugin.  If not, see <http://www.gnu.org/licenses/>.
 */
package fr.diwaly.volcano;

import org.bukkit.ChatColor;
import org.bukkit.Material;
import org.bukkit.block.Block;
import org.bukkit.event.Event;
import org.bukkit.event.player.PlayerBucketEmptyEvent;
import org.bukkit.event.player.PlayerListener;
import org.bukkit.plugin.PluginManager;

public class VolcanoPlayerListener extends PlayerListener{

	public VolcanoPlayerListener() {
		PluginManager pm = Plugin.server.getPluginManager();
		pm.registerEvent(Event.Type.PLAYER_BUCKET_EMPTY, this, Event.Priority.Normal, Plugin.him);
	}

	@Override
	public void onPlayerBucketEmpty(PlayerBucketEmptyEvent event) {
		Block block = event.getBlockClicked();
		if(event.getBucket() == Material.LAVA_BUCKET){
			for (Volcano volcano : Plugin.listVolcano) {
				if(volcano.world.getName().equals(block.getWorld().getName())){	
					if(volcano.insideChunk(block.getX(), block.getZ())){
						event.setCancelled(true);
						event.getPlayer().sendMessage(ChatColor.GRAY+"Lava Bucket empty isn't allow on volcano.");
					}
				}
			}
		}
	}
}
